################################################
# mksysdep.pl V 0.0
# Created by Chris Brown, 20 May, 208
################################################

if (! $ENV{'saclib'})
{
    print "SACLIB Error: The saclib environment variable must be set!\n";
    exit(1);
}

### Get architecture type
$ptype = "unknown";
$uname = `uname -mpi`;
if ($uname =~ /i\S*86/ or $uname =~ /x86_64/)
{
    $ptype = "x86";
}
elsif ($uname =~ /Sun|sun|SUN|Sparc|sparc|SPARC/)
{
    $ptype = "sparc";
}
else
{
    print "SACLIB Warning: Could not determine processor type!\n";
}

### Get OS type
$ostype = "unknown";
$uname = `uname -s`;
if ($uname =~ /linux|Linux|LINUX/)
{
    $ostype = "linux";
}
elsif ($uname =~ /Sun|sun|SUN|solaris|Solaris/)
{
    $ostype = "solaris";
}
else
{
    print "SACLIB Warning: Could not determine OS type!\n";
}

### Call appropriate install script
if ($ptype eq "x86" && $ostype eq "linux")
{
    system("bash -c \"pushd >/dev/null $ENV{'saclib'}/sysdep/linuxX86 ; ./install ; popd >/dev/null\"");    
}
elsif ($ptype eq "sparc" && $ostype eq "solaris")
{
    system("bash -c \"pushd >/dev/null $ENV{'saclib'}/sysdep/solarisSparc ; ./install ; popd >/dev/null\"");
}

